/*============================================================================
//  axpsi2xs.c
//
//  AXP-SI21/AXP-SI22
//
//  Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//  V1.00 Date 1999/06/8
//
//   ̃\[Xɂ AXP-SI21 ܂ AXP-SI22 CH1CH2ڑ
//   J[hCH1瑗MACH2MႪLqĂ܂B
//   ̗łCH1COM3ACH2COM4Ɋ蓖ĂĂ̂Ƃ
//   vOLqĂ܂B
//
//==========================================================================*/
#define STRICT
#include <windows.h>
#include <tchar.h>

/*-------------------------------------------------------------------------
//  װԍ
//-----------------------------------------------------------------------*/
#define AXPSI2X_ERR_NO_COMDEV       1                   /* COM޲܂ */
#define AXPSI2X_ERR_INIT            2                   /* G[ł */
#define AXPSI2X_ERR_SEND            3                   /* MG[ł */
#define AXPSI2X_ERR_RECV            4                   /* MG[ł */

/*-------------------------------------------------------------------------
//  ٖްzւ̲ޯԍ
//-----------------------------------------------------------------------*/
#define AXPSI2X_CH1                 0
#define AXPSI2X_CH2                 1

/*-------------------------------------------------------------------------
//  ۰ٕϐ
//-----------------------------------------------------------------------*/
const TCHAR szTitle[]     = _T("Sample");               /* үޯٕ */
const TCHAR szSend[]      = _T("PLUG MAGIC");           /* M镶 */
const TCHAR *szComName[2] = { _T("COM3"), _T("COM4") }; /* COM߰޲ */

/*-------------------------------------------------------------------------
//  ֐
//-----------------------------------------------------------------------*/
static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(DWORD dwCh, DWORD dwErrorNum);

/*============================================================================
//  ۸т̊Jn
//===========================================================================*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    HANDLE          hCom[2];                /* COM߰Ăւ */
    TCHAR           szBuf[256];             /* \ */
    TCHAR           szRecv[256];            /* Mp */
    DWORD           dwCh;                   /*  ޯ */
    DCB             dcb;                    /* ʐMpDCB\ */
    DWORD           dwNumWrite, dwNumRead;  /* M޲Đ */
    COMMTIMEOUTS    timeouts;               /* ʐMpѱč\ */
    BOOL            success;                /* APIĂяo */

    /*-------------------------------------------------
    // COM߰Ă݂Ȁݒs
    //-----------------------------------------------*/
    for(dwCh = AXPSI2X_CH1; dwCh <= AXPSI2X_CH2; dwCh++ ) {
        /*-------------------------------------------------
        // COM߰Ă
        //-----------------------------------------------*/
        hCom[dwCh] = CreateFile(szComName[dwCh],
                                GENERIC_READ|GENERIC_WRITE,
                                0,
                                0,
                                OPEN_EXISTING,
                                FILE_ATTRIBUTE_NORMAL,
                                0);
        if (INVALID_HANDLE_VALUE == hCom[dwCh])
            ErrorMessage(dwCh,AXPSI2X_ERR_NO_COMDEV);
        /*-------------------------------------------------
        // COM߰Ă̒ʐMݒ
        //-----------------------------------------------*/
        success = GetCommState(hCom[dwCh], &dcb);
        if (FALSE == success)
            ErrorMessage(dwCh,AXPSI2X_ERR_NO_COMDEV);
        dcb.BaudRate = 9600;            /* ްڰ:         9600bps */
        dcb.ByteSize = 8;               /* ް:         8ޯ */
        dcb.Parity = NOPARITY;          /* è:           */
        dcb.StopBits = ONESTOPBIT;      /* įޯ:      1ޯ */
        success = SetCommState(hCom[dwCh], &dcb);
        if (FALSE == success) 
            ErrorMessage(dwCh,AXPSI2X_ERR_NO_COMDEV);
        /*-------------------------------------------------
        // COM߰ĂѱĐݒ
        //-----------------------------------------------*/
        timeouts.ReadIntervalTimeout = MAXDWORD; 
        timeouts.ReadTotalTimeoutMultiplier = 100;
        timeouts.ReadTotalTimeoutConstant = 1000;
        timeouts.WriteTotalTimeoutMultiplier = 100;
        timeouts.WriteTotalTimeoutConstant = 1000;
        SetCommTimeouts(hCom[dwCh], &timeouts);
    }
    /*-------------------------------------------------
    // CH1當 "PLUG MAGIC" 𑗐M
    //-----------------------------------------------*/
    wsprintf(szBuf, _T("%s\n\n")
                    _T("Send: %s"),
                    szComName[AXPSI2X_CH1],
                    szSend);
    ResultMessage(szBuf);
    WriteFile(hCom[AXPSI2X_CH1],szSend,strlen(szSend),&dwNumWrite,NULL);
    if (dwNumWrite != strlen(szSend) )
        ErrorMessage(AXPSI2X_CH1,AXPSI2X_ERR_SEND);
    /*-------------------------------------------------
    // CH2當M
    //-----------------------------------------------*/
    ReadFile(hCom[AXPSI2X_CH2],szRecv,dwNumWrite,&dwNumRead,NULL);
    if (dwNumRead != strlen(szSend) )
        ErrorMessage(AXPSI2X_CH2,AXPSI2X_ERR_RECV);
    szRecv[dwNumRead] = '\0';
    wsprintf(szBuf, _T("%s\n\n")
                    _T("Received: %s"),
                    szComName[AXPSI2X_CH2],
                    szRecv);
    ResultMessage(szBuf);
    /*-------------------------------------------------
    // COM߰Ă۰
    //-----------------------------------------------*/
    for(dwCh = AXPSI2X_CH1; dwCh <= AXPSI2X_CH2; dwCh++ )
        CloseHandle(hCom[dwCh]);
    wsprintf(szBuf, _T("AXP-SI21/AXP-SI22\n\n")
                    _T("Success"));
    ResultMessage(szBuf);
    return 0;
}
/*============================================================================
// ʂ\
//==========================================================================*/
static void ResultMessage(LPCTSTR lpszbuf)
{
    MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}
/*============================================================================
// װүނ\
//==========================================================================*/
static void ErrorMessage(DWORD dwCh, DWORD dwErrorNum)
{
    TCHAR szBuf[50];

    switch (dwErrorNum){
        case AXPSI2X_ERR_NO_COMDEV:
            wsprintf(szBuf, _T("Ch%d\t COM open error\n\n")
                            _T("Error code\t:%08lxh"),
                            dwCh+1,
                            GetLastError());
            break;
        case AXPSI2X_ERR_INIT:
            wsprintf(szBuf, _T("Ch%d\t COM initialize error"),
                            dwCh+1);
            break;
        case AXPSI2X_ERR_SEND:
            wsprintf(szBuf, _T("Ch%d\t COM send error"),
                            dwCh+1 );
            break;
        case AXPSI2X_ERR_RECV:
            wsprintf(szBuf, _T("Ch%d\t COM receive error"),
                            dwCh+1 );
            break;
    }
    MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
    ExitProcess(1);
}
